#! /usr/bin/perl

# Identification:

$Prog = "w0code";
$Version = "1.0";

PARAM:
while ($ARGV[0] =~ /^-/) {
    $_ = shift;

    /^-v$/ and do {
	print STDERR "This is $Prog (version $Version)\n";  next PARAM; };
    /^-x$/ and do {
	$Start = shift;  next PARAM; };
    /^-x(.+)$/ and do {
	$Start = $1;  next PARAM; };

    print STDERR "$Prog: Unknown option `$_' ignored.\n";
}

DATA:
while (<>) {
    chomp;

    /^def:(.*)>>$/ and do {
	$Cur_def = $1;  $Start = $Start || $Cur_def;
	$Def{$Cur_def} .= "nl\n" if defined $Def{$Cur_def};
	next DATA; };

    /^code:.*\|\|$/ and do {
	$Def{$Cur_def} .= "$&\n";
	next DATA; };

    /^nl$/ and do {
	$Def{$Cur_def} .= "nl\n";
	next DATA; };

    /^use:.*>>$/ and do {
	$Def{$Cur_def} .= "$&\n";
	next DATA; };
}

$Pos = $N_errors = 0;
&Expand($Start);
print "\n" if $Pos>0;

exit ($N_errors ? 1 : 0);


sub Expand {
#   ------
# Expand the code of a macro symbol.
#
# Parameters:
    local($_) = shift;

    my($Line);

    unless (exists $Def{$_}) {
	print STDERR "$Prog: Symbol <<$_>> has not been defined.\n";
	++$N_errors;  return;
    }

    if ($Active{$_}) {
	print STDERR "$Prog: Definition cycle found; the loop involves:\n",
	             join(" ", sort keys %Active), "\n";
	exit 1;
    }
    $Active{$_} = 1;

    foreach $Line (split(/\n/,$Def{$_})) {
	if ($Line =~ /^code:(.*)\|\|$/) {
	    print $1;  $Pos += length($1); }
	elsif ($Line =~ /^nl$/) {
	    print "\n";  $Pos = 0; }
	elsif ($Line =~ /^use:(.*)>>$/) {
	    &Expand($1); }
	else {
	    print STDERR "$Prog: Unknown format: $Line.\n";
	    ++$N_errors;
	}
    }

    delete $Active{$_};
}
