#! /usr/bin/perl -w

$Prog = "w0pre.boot";

$False = 0;
$True  = 1;

$Macro_start = "<<";

$Last_def = "";
$New_line = $False;

# Always start in the code mode:
$Code_mode = $False;

LINE:
while (<>) {
  unless ($Cur_file) {
    $Cur_file = $ARGV;
    print "file:$Cur_file||\n";
  }
  $Cur_file = "" if eof;

  chomp;
  /^@\s*$/ and do {
    $Code_mode = $False;  $New_line = $False;
    next LINE; };

  /^$Macro_start(.*?)>>\s*=\s*/ and do {
    $Sy = &Fix_macro_sy($1);  $Code_mode = $True;
    $Cur_def = $Last_def = $Sy || $Last_def;
    print "def:$Cur_def>>\n";  $New_line = $False;
    next LINE; };

  unless ($Code_mode) {
    print "text:$_||\n";  $New_line = $False;
    next LINE; };

  print "nl\n" if $New_line;
  while (s/^(.*?)$Macro_start(.*?)>>//) {
    print "code:$1||\n" if $1;
    print "use:", &Fix_macro_sy($2), ">>\n";
  }
  print "code:$_||\n" if $_;
  $New_line = $True;
}

print "nl\n" if $New_line;
exit($N_errors ? 1 : 0);

sub Fix_macro_sy {
  local $_ = shift;

  unless (/\.{3}$/) {
      $Macro{$_} = "Defined";  return $_ ;
  }

  my $pattern = $`;
  my @match = grep /^$pattern/, keys %Macro;

  if (@match == 0) {
    print STDERR "$Prog: No match for <<$_>>.\n";  
    ++$N_errors;  return "??";
  } elsif (@match == 1) {
    return $match[0];
  } else {
    print STDERR "$Prog: ", 0+@match, " match for <<$_>>.\n";
    print STDERR "       Possiblitites: @match.\n";
    ++$N_errors;  return $match[0];
  }
}
